/* EmailPlugin.c generated by valac 0.48.13, the Vala compiler
 * generated from EmailPlugin.vala, do not modify */

/*-
 * Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gsignond.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define GSIGNOND_TYPE_MAIL_PLUGIN (gsignond_mail_plugin_get_type ())
#define GSIGNOND_MAIL_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSIGNOND_TYPE_MAIL_PLUGIN, GSignondMailPlugin))
#define GSIGNOND_MAIL_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSIGNOND_TYPE_MAIL_PLUGIN, GSignondMailPluginClass))
#define GSIGNOND_IS_MAIL_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSIGNOND_TYPE_MAIL_PLUGIN))
#define GSIGNOND_IS_MAIL_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSIGNOND_TYPE_MAIL_PLUGIN))
#define GSIGNOND_MAIL_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSIGNOND_TYPE_MAIL_PLUGIN, GSignondMailPluginClass))

typedef struct _GSignondMailPlugin GSignondMailPlugin;
typedef struct _GSignondMailPluginClass GSignondMailPluginClass;
typedef struct _GSignondMailPluginPrivate GSignondMailPluginPrivate;
enum  {
	GSIGNOND_MAIL_PLUGIN_0_PROPERTY,
	GSIGNOND_MAIL_PLUGIN_TYPE_PROPERTY,
	GSIGNOND_MAIL_PLUGIN_MECHANISMS_PROPERTY,
	GSIGNOND_MAIL_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* gsignond_mail_plugin_properties[GSIGNOND_MAIL_PLUGIN_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GSignondMailPlugin {
	GObject parent_instance;
	GSignondMailPluginPrivate * priv;
};

struct _GSignondMailPluginClass {
	GObjectClass parent_class;
};

static gpointer gsignond_mail_plugin_parent_class = NULL;
static GSignondPluginInterface * gsignond_mail_plugin_gsignond_plugin_parent_iface = NULL;

GType gsignond_mail_plugin_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GSignondMailPlugin, g_object_unref)
static void gsignond_mail_plugin_real_cancel (GSignondPlugin* base);
static void gsignond_mail_plugin_real_request_initial (GSignondPlugin* base,
                                                GSignondSessionData* session_data,
                                                GSignondDictionary* token_cache,
                                                const gchar* mechanism);
static void gsignond_mail_plugin_real_request (GSignondPlugin* base,
                                        GSignondSessionData* session_data);
static void gsignond_mail_plugin_real_user_action_finished (GSignondPlugin* base,
                                                     GSignondSignonuiData* ui_data);
static void gsignond_mail_plugin_real_refresh (GSignondPlugin* base,
                                        GSignondSignonuiData* session_data);
GSignondMailPlugin* gsignond_mail_plugin_new (void);
GSignondMailPlugin* gsignond_mail_plugin_construct (GType object_type);
static GType gsignond_mail_plugin_get_type_once (void);
static void _vala_gsignond_mail_plugin_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);

static void
gsignond_mail_plugin_real_cancel (GSignondPlugin* base)
{
	GSignondMailPlugin * self;
	GError* signond_error = NULL;
	GError* _tmp0_;
	self = (GSignondMailPlugin*) base;
	_tmp0_ = g_error_new_literal (GSIGNOND_ERROR, GSIGNOND_ERROR_SESSION_CANCELED, "Session canceled");
	signond_error = _tmp0_;
	gsignond_plugin_error ((GSignondPlugin*) self, signond_error);
	_g_error_free0 (signond_error);
}

static void
gsignond_mail_plugin_real_request_initial (GSignondPlugin* base,
                                           GSignondSessionData* session_data,
                                           GSignondDictionary* token_cache,
                                           const gchar* mechanism)
{
	GSignondMailPlugin * self;
	gchar* username = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* secret = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GSignondSignonuiData* user_action_data = NULL;
	GSignondSignonuiData* _tmp15_;
	const gchar* _tmp16_;
	GSignondSignonuiData* _tmp21_;
	GSignondSignonuiData* _tmp22_;
	GSignondSignonuiData* _tmp23_;
	self = (GSignondMailPlugin*) base;
	g_return_if_fail (session_data != NULL);
	g_return_if_fail (token_cache != NULL);
	g_return_if_fail (mechanism != NULL);
	_tmp0_ = gsignond_session_data_get_username (session_data);
	_tmp1_ = g_strdup (_tmp0_);
	username = _tmp1_;
	_tmp2_ = gsignond_session_data_get_secret (session_data);
	_tmp3_ = g_strdup (_tmp2_);
	secret = _tmp3_;
	_tmp4_ = secret;
	if (_tmp4_ != NULL) {
		GSignondSessionData* response = NULL;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GSignondSessionData* _tmp7_;
		GSignondSessionData* _tmp8_;
		const gchar* _tmp9_;
		GSignondSessionData* _tmp12_;
		const gchar* _tmp13_;
		GSignondSessionData* _tmp14_;
		_tmp5_ = gsignond_dictionary_to_variant (token_cache);
		_tmp6_ = _tmp5_;
		_tmp7_ = gsignond_session_data_new_from_variant (_tmp6_);
		_tmp8_ = _tmp7_;
		_g_variant_unref0 (_tmp6_);
		response = _tmp8_;
		_tmp9_ = username;
		if (_tmp9_ != NULL) {
			GSignondSessionData* _tmp10_;
			const gchar* _tmp11_;
			_tmp10_ = response;
			_tmp11_ = username;
			gsignond_session_data_set_username (_tmp10_, _tmp11_);
		}
		_tmp12_ = response;
		_tmp13_ = secret;
		gsignond_session_data_set_secret (_tmp12_, _tmp13_);
		_tmp14_ = response;
		gsignond_plugin_response_final ((GSignondPlugin*) self, _tmp14_);
		_g_object_unref0 (response);
		_g_free0 (secret);
		_g_free0 (username);
		return;
	}
	_tmp15_ = gsignond_signonui_data_new ();
	user_action_data = _tmp15_;
	_tmp16_ = username;
	if (_tmp16_ == NULL) {
		GSignondSignonuiData* _tmp17_;
		_tmp17_ = user_action_data;
		gsignond_signonui_data_set_query_username (_tmp17_, TRUE);
	} else {
		GSignondSignonuiData* _tmp18_;
		GSignondSignonuiData* _tmp19_;
		const gchar* _tmp20_;
		_tmp18_ = user_action_data;
		gsignond_signonui_data_set_query_username (_tmp18_, FALSE);
		_tmp19_ = user_action_data;
		_tmp20_ = username;
		gsignond_signonui_data_set_username (_tmp19_, _tmp20_);
	}
	_tmp21_ = user_action_data;
	gsignond_dictionary_set_boolean ((GSignondDictionary*) _tmp21_, "AskEmailSettings", TRUE);
	_tmp22_ = user_action_data;
	gsignond_signonui_data_set_query_password (_tmp22_, TRUE);
	_tmp23_ = user_action_data;
	gsignond_plugin_user_action_required ((GSignondPlugin*) self, _tmp23_);
	_g_object_unref0 (user_action_data);
	_g_free0 (secret);
	_g_free0 (username);
}

static void
gsignond_mail_plugin_real_request (GSignondPlugin* base,
                                   GSignondSessionData* session_data)
{
	GSignondMailPlugin * self;
	GError* err = NULL;
	GError* _tmp0_;
	self = (GSignondMailPlugin*) base;
	g_return_if_fail (session_data != NULL);
	_tmp0_ = g_error_new_literal (GSIGNOND_ERROR, GSIGNOND_ERROR_WRONG_STATE, "Email plugin doesn't support request");
	err = _tmp0_;
	gsignond_plugin_error ((GSignondPlugin*) self, err);
	_g_error_free0 (err);
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

static void
gsignond_mail_plugin_real_user_action_finished (GSignondPlugin* base,
                                                GSignondSignonuiData* ui_data)
{
	GSignondMailPlugin * self;
	GSignondSignonuiError query_error = 0;
	GSignondSignonuiError _tmp0_ = 0;
	gboolean _tmp1_;
	GSignondSignonuiError _tmp4_;
	self = (GSignondMailPlugin*) base;
	g_return_if_fail (ui_data != NULL);
	_tmp1_ = gsignond_signonui_data_get_query_error (ui_data, &_tmp0_);
	query_error = _tmp0_;
	if (_tmp1_ == FALSE) {
		GError* err = NULL;
		GError* _tmp2_;
		GError* _tmp3_;
		_tmp2_ = g_error_new_literal (GSIGNOND_ERROR, GSIGNOND_ERROR_USER_INTERACTION, "user_action_finished did not return an error value");
		err = _tmp2_;
		_tmp3_ = err;
		gsignond_plugin_error ((GSignondPlugin*) self, _tmp3_);
		_g_error_free0 (err);
		return;
	}
	_tmp4_ = query_error;
	if (_tmp4_ == SIGNONUI_ERROR_NONE) {
		GSignondSessionData* response = NULL;
		GSignondSessionData* _tmp5_;
		GSignondSessionData* _tmp6_;
		const gchar* _tmp7_;
		GSignondSessionData* _tmp8_;
		const gchar* _tmp9_;
		GSignondSessionData* _tmp10_;
		const gchar* _tmp11_;
		GVariant* imap_port_var = NULL;
		GVariant* _tmp12_;
		GVariant* _tmp13_;
		GVariant* _tmp14_;
		GSignondSessionData* _tmp17_;
		const gchar* _tmp18_;
		GSignondSessionData* _tmp19_;
		const gchar* _tmp20_;
		GSignondSessionData* _tmp21_;
		const gchar* _tmp22_;
		GSignondSessionData* _tmp23_;
		const gchar* _tmp24_;
		GVariant* smtp_port_var = NULL;
		GVariant* _tmp25_;
		GVariant* _tmp26_;
		GVariant* _tmp27_;
		GSignondSessionData* _tmp30_;
		const gchar* _tmp31_;
		GSignondSessionData* _tmp32_;
		const gchar* _tmp33_;
		GSignondSessionData* _tmp34_;
		const gchar* _tmp35_;
		GSignondSessionData* _tmp36_;
		GSignondSessionData* _tmp37_;
		_tmp5_ = gsignond_session_data_new ();
		response = _tmp5_;
		_tmp6_ = response;
		_tmp7_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "ImapUser");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp6_, "ImapUser", _tmp7_);
		_tmp8_ = response;
		_tmp9_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "ImapPassword");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp8_, "ImapPassword", _tmp9_);
		_tmp10_ = response;
		_tmp11_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "ImapServer");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp10_, "ImapServer", _tmp11_);
		_tmp12_ = gsignond_dictionary_get ((GSignondDictionary*) ui_data, "ImapPort");
		_tmp13_ = _g_variant_ref0 (_tmp12_);
		imap_port_var = _tmp13_;
		_tmp14_ = imap_port_var;
		if (_tmp14_ != NULL) {
			GSignondSessionData* _tmp15_;
			GVariant* _tmp16_;
			_tmp15_ = response;
			_tmp16_ = imap_port_var;
			gsignond_dictionary_set ((GSignondDictionary*) _tmp15_, "ImapPort", _tmp16_);
		}
		_tmp17_ = response;
		_tmp18_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "ImapSecurity");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp17_, "ImapSecurity", _tmp18_);
		_tmp19_ = response;
		_tmp20_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "SmtpUser");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp19_, "SmtpUser", _tmp20_);
		_tmp21_ = response;
		_tmp22_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "SmtpPassword");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp21_, "SmtpPassword", _tmp22_);
		_tmp23_ = response;
		_tmp24_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "SmtpServer");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp23_, "SmtpServer", _tmp24_);
		_tmp25_ = gsignond_dictionary_get ((GSignondDictionary*) ui_data, "SmtpPort");
		_tmp26_ = _g_variant_ref0 (_tmp25_);
		smtp_port_var = _tmp26_;
		_tmp27_ = smtp_port_var;
		if (_tmp27_ != NULL) {
			GSignondSessionData* _tmp28_;
			GVariant* _tmp29_;
			_tmp28_ = response;
			_tmp29_ = smtp_port_var;
			gsignond_dictionary_set ((GSignondDictionary*) _tmp28_, "SmtpPort", _tmp29_);
		}
		_tmp30_ = response;
		_tmp31_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "SmtpSecurity");
		gsignond_dictionary_set_string ((GSignondDictionary*) _tmp30_, "SmtpSecurity", _tmp31_);
		_tmp32_ = response;
		_tmp33_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "ImapUser");
		gsignond_session_data_set_username (_tmp32_, _tmp33_);
		_tmp34_ = response;
		_tmp35_ = gsignond_dictionary_get_string ((GSignondDictionary*) ui_data, "ImapPassword");
		gsignond_session_data_set_secret (_tmp34_, _tmp35_);
		_tmp36_ = response;
		gsignond_plugin_store ((GSignondPlugin*) self, (GSignondDictionary*) _tmp36_);
		_tmp37_ = response;
		gsignond_plugin_response_final ((GSignondPlugin*) self, _tmp37_);
		_g_variant_unref0 (smtp_port_var);
		_g_variant_unref0 (imap_port_var);
		_g_object_unref0 (response);
	} else {
		GSignondSignonuiError _tmp38_;
		_tmp38_ = query_error;
		if (_tmp38_ == SIGNONUI_ERROR_CANCELED) {
			GError* err = NULL;
			GError* _tmp39_;
			GError* _tmp40_;
			_tmp39_ = g_error_new_literal (GSIGNOND_ERROR, GSIGNOND_ERROR_SESSION_CANCELED, "Session canceled");
			err = _tmp39_;
			_tmp40_ = err;
			gsignond_plugin_error ((GSignondPlugin*) self, _tmp40_);
			_g_error_free0 (err);
		} else {
			GError* err = NULL;
			GSignondSignonuiError _tmp41_;
			GError* _tmp42_;
			GError* _tmp43_;
			_tmp41_ = query_error;
			_tmp42_ = g_error_new (GSIGNOND_ERROR, GSIGNOND_ERROR_USER_INTERACTION, "userActionFinished error: %d", (gint) _tmp41_);
			err = _tmp42_;
			_tmp43_ = err;
			gsignond_plugin_error ((GSignondPlugin*) self, _tmp43_);
			_g_error_free0 (err);
		}
	}
}

static void
gsignond_mail_plugin_real_refresh (GSignondPlugin* base,
                                   GSignondSignonuiData* session_data)
{
	GSignondMailPlugin * self;
	self = (GSignondMailPlugin*) base;
	g_return_if_fail (session_data != NULL);
	gsignond_plugin_refreshed ((GSignondPlugin*) self, session_data);
}

GSignondMailPlugin*
gsignond_mail_plugin_construct (GType object_type)
{
	GSignondMailPlugin * self = NULL;
	self = (GSignondMailPlugin*) g_object_new (object_type, NULL);
	return self;
}

GSignondMailPlugin*
gsignond_mail_plugin_new (void)
{
	return gsignond_mail_plugin_construct (GSIGNOND_TYPE_MAIL_PLUGIN);
}

static gchar*
gsignond_mail_plugin_real_get_type (GSignondPlugin* base)
{
	gchar* result;
	GSignondMailPlugin* self;
	gchar* _tmp0_;
	self = (GSignondMailPlugin*) base;
	_tmp0_ = g_strdup ("mail");
	result = _tmp0_;
	return result;
}

static gchar**
gsignond_mail_plugin_real_get_mechanisms (GSignondPlugin* base)
{
	gchar** result;
	GSignondMailPlugin* self;
	gchar* _tmp0_;
	gchar** _tmp1_;
	self = (GSignondMailPlugin*) base;
	_tmp0_ = g_strdup ("mail");
	_tmp1_ = g_new0 (gchar*, 2 + 1);
	_tmp1_[0] = _tmp0_;
	_tmp1_[1] = NULL;
	result = _tmp1_;
	return result;
}

static void
gsignond_mail_plugin_class_init (GSignondMailPluginClass * klass,
                                 gpointer klass_data)
{
	gsignond_mail_plugin_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_gsignond_mail_plugin_get_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GSIGNOND_MAIL_PLUGIN_TYPE_PROPERTY, gsignond_mail_plugin_properties[GSIGNOND_MAIL_PLUGIN_TYPE_PROPERTY] = g_param_spec_string ("type", "type", "type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GSIGNOND_MAIL_PLUGIN_MECHANISMS_PROPERTY, gsignond_mail_plugin_properties[GSIGNOND_MAIL_PLUGIN_MECHANISMS_PROPERTY] = g_param_spec_boxed ("mechanisms", "mechanisms", "mechanisms", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
gsignond_mail_plugin_gsignond_plugin_interface_init (GSignondPluginInterface * iface,
                                                     gpointer iface_data)
{
	gsignond_mail_plugin_gsignond_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->cancel = (void (*) (GSignondPlugin*)) gsignond_mail_plugin_real_cancel;
	iface->request_initial = (void (*) (GSignondPlugin*, GSignondSessionData*, GSignondDictionary*, const gchar*)) gsignond_mail_plugin_real_request_initial;
	iface->request = (void (*) (GSignondPlugin*, GSignondSessionData*)) gsignond_mail_plugin_real_request;
	iface->user_action_finished = (void (*) (GSignondPlugin*, GSignondSignonuiData*)) gsignond_mail_plugin_real_user_action_finished;
	iface->refresh = (void (*) (GSignondPlugin*, GSignondSignonuiData*)) gsignond_mail_plugin_real_refresh;
}

static void
gsignond_mail_plugin_instance_init (GSignondMailPlugin * self,
                                    gpointer klass)
{
}

/**
 * = Mail authentication plugin for gSSO single sign-on service =
 *
 * The Mail plugin is a simple plugin to acquire and store the credentials.
 * It currently only handle credentials for IMAP and SMTP.
 *
 * The plugin implements the standard {@link GSignond.Plugin} interface, and after instantiating
 * a plugin object all interactions happen through that interface.
 *
 * {@link GSignond.Plugin.type} property of the plugin object is set to "mail".
 *
 * {@link GSignond.Plugin.mechanisms} property of the plugin object is set to "mail".
 *
 * ==Token and its parameters in {@link GSignond.Plugin.response_final} signal==
 *
 * {@link GSignond.Plugin.response_final} signal concludes the process and returns a
 * {@link GSignond.Dictionary} parameter that contains the access parameters:
 *
 *  * "ImapUser" //(mandatory)// - the IMAP username
 *  * "ImapPassword" //(mandatory)// - the IMAP password
 *  * "ImapServer" //(mandatory)// - the IMAP host
 *  * "ImapPort" //(mandatory)// - the IMAP port of the host
 *  * "ImapSecurity" //(mandatory)// - the security kind of the IMAP server
 *    can be one of "None", "SSL/TLS" or "STARTTLS"
 *  * "SmtpUser" //(mandatory)// - the SMTP username
 *  * "SmtpPassword" //(mandatory)// - the SMTP password
 *  * "SmtpServer" //(mandatory)// - the SMTP host
 *  * "SmtpPort" //(mandatory)// - the SMTP port of the host
 *  * "SmtpSecurity" //(mandatory)// - the security kind of the SMTP server
 *    can be one of "None", "SSL/TLS" or "STARTTLS"
 *
 * @see GSignond.Plugin
 */
static GType
gsignond_mail_plugin_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GSignondMailPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gsignond_mail_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GSignondMailPlugin), 0, (GInstanceInitFunc) gsignond_mail_plugin_instance_init, NULL };
	static const GInterfaceInfo gsignond_plugin_info = { (GInterfaceInitFunc) gsignond_mail_plugin_gsignond_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gsignond_mail_plugin_type_id;
	gsignond_mail_plugin_type_id = g_type_register_static (G_TYPE_OBJECT, "GSignondMailPlugin", &g_define_type_info, 0);
	g_type_add_interface_static (gsignond_mail_plugin_type_id, gsignond_plugin_get_type (), &gsignond_plugin_info);
	return gsignond_mail_plugin_type_id;
}

GType
gsignond_mail_plugin_get_type (void)
{
	static volatile gsize gsignond_mail_plugin_type_id__volatile = 0;
	if (g_once_init_enter (&gsignond_mail_plugin_type_id__volatile)) {
		GType gsignond_mail_plugin_type_id;
		gsignond_mail_plugin_type_id = gsignond_mail_plugin_get_type_once ();
		g_once_init_leave (&gsignond_mail_plugin_type_id__volatile, gsignond_mail_plugin_type_id);
	}
	return gsignond_mail_plugin_type_id__volatile;
}

static void
_vala_gsignond_mail_plugin_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GSignondMailPlugin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GSIGNOND_TYPE_MAIL_PLUGIN, GSignondMailPlugin);
	switch (property_id) {
		case GSIGNOND_MAIL_PLUGIN_TYPE_PROPERTY:
		g_value_take_string (value, gsignond_mail_plugin_real_get_type ((GSignondPlugin*) self));
		break;
		case GSIGNOND_MAIL_PLUGIN_MECHANISMS_PROPERTY:
		g_value_take_boxed (value, gsignond_mail_plugin_real_get_mechanisms ((GSignondPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

